<template>
  <v-dialog
    ref="addStorage"
    v-model="dialog"
    max-width="900px"
    persistent
  >
    <v-card>
      <v-form ref="form">
        <v-card-title class="text-left info pb-2">
          <h2
            class="headline"
            text-color="white"
          >
            NHẬP KHO
          </h2>
        </v-card-title>

        <v-divider />

        <v-card-text>
          <v-container class="pt-0 pb-0 mb-0">
            <v-col
              cols="12"
              lg="12"
              class="ml-2 mr-5 light-gray pb-0"
            >
              <v-row class="cols">
                <v-col
                  cols="12"
                  lg="4"
                  class="pl-0 pt-0 pb-0 pr-5"
                >
                  <v-row class="pl-2 pt-0 pb-0 pr-5 cols">
                    <span>Hình ảnh</span>
                  </v-row>
                  <v-row class="pl-2 pt-0 pb-0 pr-5 cols">
                    <v-col
                      cols="12"
                      class="text-center pt-0 pb-0 pl-0 main-thumb"
                    >
                      <div
                        :style="{ 'background-image': `url(${imageStore1})` }"
                        class="image-input m-auto rounded-lg"
                        width="500px"
                      />
                    </v-col>
                  </v-row>
                </v-col>
                <v-col
                  cols="12"
                  lg="8"
                  class="pl-0 pt-0 pb-0 pr-5"
                >
                  <v-row class="cols">
                    <!-- Thông tin sản phẩm  -->
                    <v-col
                      md="9"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-autocomplete
                        v-model="productStorageModel.name_product"
                        :items="productList"
                        ref="nameproduct"
                        :search-input.sync="searchInput"
                        return-object
                        item-text="name"
                        label="Tên hàng (*)"
                        :rules="nameRules"
                        required
                        clearable
                        @change="productChange($event)"
                      />
                    </v-col>
                    <v-col
                      md="3"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-text-field
                        ref="codeproduct"
                        v-model="productStorageModel.product_code"
                        label="Mã hàng (*)"
                        required
                        readonly
                        disabled
                        :rules="nameRules"
                      />
                    </v-col>
                  </v-row>

                  <v-row class="cols">
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-text-field
                        v-model="productStorageModel.stock_current"
                        label="Tồn kho hiện tại"
                        readonly
                        disabled
                      />
                    </v-col>
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-text-field
                        v-model="productStorageModel.previous_price"
                        label="Giá nhập kỳ trước"
                        readonly
                        disabled
                      />
                    </v-col>
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 pr-0 col"
                    >
                      <v-autocomplete
                        ref="refDVTCu"
                        v-model="productStorageModel.previous_DVT"
                        :search-input.sync="searchDVT"
                        item-text="name"
                        label="ĐVT cũ"
                        multiple
                        readonly
                        disabled
                      />
                    </v-col>
                  </v-row>

                  <!-- Thông tin nhập hàng  -->
                  <v-row class="cols">
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-text-field
                        ref="receiptquatity"
                        v-model="productStorageModel.receipt_quatity"
                        label="Số lượng nhập"
                        :rules="numberRule"
                        class="pr-5"
                        clearable
                        required
                        autofocus
                      />
                    </v-col>
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-text-field
                        ref="receiptprice"
                        v-model="productStorageModel.receipt_price"
                        label="Giá nhập"
                        :rules="priceRule"
                        required
                        clearable
                        align="right"
                      />
                    </v-col>
                    <v-col
                      md="4"
                      class="pl-0 pt-0 pb-0 pr-0 col"
                    >
                      <v-autocomplete
                        ref="receipspec"
                        v-model="productStorageModel.receipt_spec"
                        :items="specs"
                        :search-input.sync="searchDVT"
                        :rules="specRule"
                        item-text="name"
                        multiple
                        required
                        label="ĐVT nhập hàng"
                      />
                    </v-col>
                  </v-row>

                  <v-row class="cols">
                    <v-col
                      md="6"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-autocomplete
                        v-model="productStorageModel.category_code"
                        :items="category"
                        label="Danh mục"
                        item-text="name"
                        item-value="code"
                      />
                    </v-col>
                    <v-col
                      md="6"
                      class="pl-0 pt-0 pb-0 col"
                    >
                      <v-autocomplete
                        v-model="productStorageModel.receipt_suppiler"
                        :items="suppiler_code"
                        label="Nhà cung cấp"
                      />
                    </v-col>
                  </v-row>
                </v-col>
              </v-row>
              <v-row class="mt-5" />
              <v-row>
                <v-textarea
                  ref="refNotes"
                  v-model="productStorageModel.note"
                  rows="3"
                  label="Ghi chú"
                  class="font-2em"
                  clearable
                />
              </v-row>
            </v-col>
          </v-container>
        </v-card-text>

        <v-divider />

        <v-card-actions>
          <v-spacer />

          <v-btn
            color="primary"
            class="mr-0"
            @click="insertStorage"
          >
            Nhập kho
            <v-icon right>
              save
            </v-icon>
          </v-btn>

          <v-btn
            color="error"
            @click.native="dialog = false"
          >
            Đóng
            <v-icon right>
              clear
            </v-icon>
          </v-btn>
        </v-card-actions>
      </v-form>
    </v-card>
  </v-dialog>
</template>

<script>
  import axios from 'axios'
  import config from '../../config/config.js'

  export default {
    layout: 'addstorage',
    components: {},
    data () {
      return {
        dialog: false,
        searchDVT: '',
        searchInput: '',
        imageStore1: 'https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d',
        specs: [],
        productList: [
          {
            id: 1,
            code: 'SP',
            name: '',
            category_code: '',
            specification: {
              DVT: ['GÓI', 'THÙNG', 'KG'],
            },
            net: '0',
            wholesale_price: '0',
            retail_price: '0',
            quota_whosale: '0',
            quatity_inventory: '0',
            note: {
              note: '',
            },
            img_url: {
              thumbs: '',
            },
            real_price: '0',
            create_date: '2020-10-20T07:57:39.000Z',
            create_user: 1,
            update_date: '2020-10-20T07:57:39.000Z',
            suppiler_code: '',
            product_code: '',
            previous_price: 0,
            stock_current: 0,
            receipt_suppiler: '',
            previous_DVT: {},
          },
        ],
        specification: ['GÓI', 'THÙNG', 'KG', 'CÁI', 'HỘP'],
        suppiler_code: ['NCC1'],
        category: [],
        seqOb: {
          seqCode: 'SP',
          seqName: 'product_code_seq',
          seqDigitNumber: 5,
        },
        productStorageModel: {
          code: '',
          name_product: '',
          category_code: '',
          specification: '',
          net: '',
          wholesale_price: '0',
          retail_price: '0',
          quota_whosale: '0',
          quatity_inventory: '0',
          note: '',
          img_url: '{ "A": "B" }',
          real_price: '0',
          create_user: '1',
          receipt_suppiler: '',
        },
        nameRules: [(v) => !!v || 'The field is required'],
        numberRule: [(v) => !!v || 'The field is required'],
        priceRule: [(v) => !!v || 'The field is required'],
        specRule: [(v) => !!v || 'The field is required'],
        dvtRules: [(v) => !!v || 'The field is required'],
      }
    },
    computed: {},
    mounted: function () {}, // end method
    created () {
      this.getProductList()
      this.getSpecs()
      this.getCategories()
    }, // end data
    methods: {
      validate () {
        let flag = true
        this.$refs.form.validate()
        this.$nextTick(function () {
          // Product name

          if (!this.$refs.receiptquatity.validate()) {
            flag = false
            this.$refs.receiptquatity.focus()
          } else if (!this.$refs.receiptprice.validate()) {
            flag = false
            this.$refs.receiptprice.focus()
          } else if (!this.$refs.receipspec.validate()) {
            flag = false
            this.$refs.receipspec.focus()
          }

          // //Ton kho toi thieu
          // else if(!this.$refs.qtyinventory.validate()){
          //   this.$refs.qtyinventory.focus();
          // }
          // else if (!this.$refs.category.validate()) {
          //   flag = false;
          //   this.$refs.category.focus();
          // } else if (!this.$refs.suppiler.validate()) {
          //   flag = false;
          //   this.$refs.suppiler.focus();
          // }
          return flag
        })
      },
      async insertStorage () {
        // console.log("Valid store ok:" + this.validate());
        // eslint-disable-next-line no-unused-vars
        const chitieu = JSON.stringify(this.chitieuModel)
        const seft = this
        this.productStorageModel.note = JSON.stringify({
          note: this.productStorageModel.note,
        })
        this.productStorageModel.specification = JSON.stringify({
          DVT: this.productStorageModel.specification,
        })
        this.productStorageModel.receipt_suppiler = JSON.stringify({
          NCC: this.productStorageModel.receipt_suppiler,
        })
        // this.productStorageModel.previous_price = this.productStorageModel.real_price;
        await axios
          .post(
            config.API_FAMILY + '/api/insertStorage',
            this.productStorageModel,
          )
          .then(function (response) {
            seft.dialog = false
            console.log('Valid store ok')
            console.log(response.data.data)
            seft.$emit('refeshList')
          })
      },
      refeshList () {
        this.dialog = false
        this.$emit('refeshList')
      },
      productChange (object) {
        console.log(object)
        console.log('Code')
        console.log(object.code)
        this.productStorageModel.code = object.code

        this.productStorageModel.product_code = object.code
        this.productStorageModel.quatity_inventory = object.quatity_inventory
        this.productStorageModel.category_code = object.category_code
        this.productStorageModel.suppiler_code = object.suppiler_code

        this.productStorageModel.previous_price = object.real_price
        this.productStorageModel.stock_current = object.quatity_inventory

      // quatity_inventory
      },
      async getSpecs () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getSpecs')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.specs = response.data.data
          })
      },
      async getProductList () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getListProduct')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.productList = response.data.data
          })
      },
      async getCategories () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getCategories')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.category = response.data.data
          })
      },
      chooseImage (ref) {
        if (ref === 'THUMB_1') {
          this.$refs.fileInput1.click()
        }
        if (ref === 'THUMB_2') {
          this.$refs.fileInput2.click()
        }
        if (ref === 'THUMB_3') {
          this.$refs.fileInput3.click()
        }
        if (ref === 'THUMB_4') {
          this.$refs.fileInput4.click()
        }
        if (ref === 'THUMB_5') {
          this.$refs.fileInput5.click()
        }
      },
      onSelectFile1 () {
        console.log('onSelectFile1')
        const input = this.$refs.fileInput1
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = (e) => {
            this.imageData1 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
    }, // end created
  } // End exxport default
</script>
<style scoped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
.table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
}
</style>
